package org.wronka.matt.Okc;

import java.io.IOException;
import java.util.Vector;
import java.net.URLEncoder;

public class Mail {
	final static String mailbox_url = "/mailbox";
	protected OKConnection c;

	public Mail(OKConnection c) {
		this.c = c;
	}

	/*
	 * Returns a listing of messages in the mailbox 
	 * (first page only currently)
	 */
	public void getMailbox(Vector v, int folder, boolean unreadOnly) throws IOException {
		final String status_flag = "<tr class=\"";
		final String from_flag = "\"/profile?u=";
		final String sysfrom_flag = "<span class=\"msgSysName\">";
		final String href_flag = "mailbox?readmsg=";
		StringBuffer data = new StringBuffer(1024);
		c.send(Mail.mailbox_url+"?folder="+folder, "", "GET", data);
		int mailStart = data.indexOf("mailList");
		int mailEnd = data.indexOf("/MESSAGES");
		int currLoc = mailStart;
		while(currLoc < mailEnd) {
			String s = data.substring(currLoc, mailEnd);
			int msg_start = s.indexOf(status_flag);
			if(msg_start < 0) break;
			s = s.substring(msg_start);
			String status = s.substring(status_flag.length());
			status = status.substring(0, status.indexOf('"'));

			String from;
			if((s.indexOf(from_flag) < s.indexOf(sysfrom_flag))
					&& s.indexOf(from_flag) >=0
					|| s.indexOf(sysfrom_flag) <0) {
				from = s.substring(s.indexOf(from_flag)+
						from_flag.length());
				from = from.substring(0, from.indexOf('"'));
			} else {
				from = s.substring(s.indexOf(sysfrom_flag)+
						sysfrom_flag.length());
				from = from.substring(0, from.indexOf('<'));
			}
			String url = s.substring(s.indexOf(href_flag));
			url = url.substring(0, url.indexOf('"'));

			String subject = s.substring(s.indexOf(url)+
					url.length()+2);
			subject = subject.substring(0, subject.indexOf("</a>")).trim();
			int nextoffset = s.substring(1).indexOf("<tr");
			if(nextoffset < 0) {
				break;
			}
			currLoc+= nextoffset + msg_start +1;

			if(!unreadOnly || status.equals("unreadMessage")) {
				Message msg = new Message(from, url, subject);
				v.add(msg);
			}
		}
		
	}

	/*
	 * Gets the message body.
	 */
	public Message retrieveBody(Message message) throws IOException {
		final String bflag = "name=\"body\" value=\"";
		String body; 
		int bStart, bEnd;
		StringBuffer data = new StringBuffer(1024);
		c.send('/'+message.getURL(), "", "GET", data);
		bStart = data.indexOf(bflag)+bflag.length();
		bEnd = data.indexOf("\"", bStart);
		body = data.substring(bStart, bEnd);
		message.setBody(body);
		return message;
	}

	public void sendMessage(Message message) throws IOException {
		String data;
		StringBuffer resp = new StringBuffer(1024);
		data = "body="+URLEncoder.encode(message.getBody()) +
			"&r1="+URLEncoder.encode(message.getFrom()) +
			"&subject="+URLEncoder.encode(message.getSubject()) +
			"&f2=&r2=&folderid=1&sendmsg=Send+Message&contactflag=compose";
		c.send(mailbox_url, data, "POST", resp);
		//c.send(mailbox_url, data, "POST", null);
		//System.out.println(message.getFrom());
		//System.out.println(message.getSubject());
		//System.out.println(message.getBody());
		//System.out.println(resp);
	}
}
